import java.io.*;
class EncoderCreator{
    public static void main(String[]args){
        try{
            FileOutputStream fos=new FileOutputStream("xproencoder.txt");
            PrintStream ps=new PrintStream(fos);
            long[]colors=new long[16];
            colors[0]=0;
            colors[1]=127;
            colors[2]=32512;
            colors[3]=32639;
            colors[4]=8323072;
            colors[5]=8323199;
            colors[6]=8355584;
            colors[7]=8355711;
            colors[8]=12566463;
            colors[9]=255;
            colors[10]=65280;
            colors[11]=65535;
            colors[12]=16711680;
            colors[13]=16711935;
            colors[14]=16776960;
            colors[15]=16777215;
            ps.println("MODULE COLORENCODER{");
            ps.println("CYCLE 0;");
            ps.println("IN in1;");
            ps.println("IN in2;");
            ps.println("IN in3;");
            ps.println("IN in4;");
            ps.println("IN in5;");
            ps.println("IN in6;");
            ps.println("IN in7;");
            ps.println("IN in8;");
            ps.println("IN in9;");
            ps.println("IN in10;");
            ps.println("IN in11;");
            ps.println("IN in12;");
            ps.println("IN in13;");
            ps.println("IN in14;");
            ps.println("IN in15;");
            ps.println("IN in16;");
            ps.println("IN in17;");
            ps.println("IN in18;");
            ps.println("IN in19;");
            ps.println("IN in20;");
            ps.println("IN in21;");
            ps.println("IN in22;");
            ps.println("IN in23;");
            ps.println("IN in24;");
            ps.println("IN in25;");
            ps.println("IN in26;");
            ps.println("IN in27;");
            ps.println("IN in28;");
            ps.println("IN in29;");
            ps.println("IN in30;");
            ps.println("IN in31;");
            ps.println("IN in32;");
            ps.println("IN sel1;");
            ps.println("IN sel2;");
            ps.println("IN sel3;");
            for(int i=0;i<32;i++){
                ps.println("OUT out"+(i+1)+";");
            }
            ps.println("INV sel1invin sel1invout;");
            ps.println("INV sel2invin sel2invout;");
            ps.println("INV sel3invin sel3invout;");
            ps.println("CONSTANT c 0;");
            ps.println("CONSTANT d 1;");
            for(int j=0;j<8;j++){
                ps.println("AND seland"+(j+1)+"in1 seland"+(j+1)+"in2 seland"+(j+1)+"out;");
                ps.println("AND bseland"+(j+1)+"in1 bseland"+(j+1)+"in2 bseland"+(j+1)+"out;");
                ps.println("AND cselanda"+(j+1)+"in1 cselanda"+(j+1)+"in2 cselanda"+(j+1)+"out;");
                ps.println("AND cselandb"+(j+1)+"in1 cselandb"+(j+1)+"in2 cselandb"+(j+1)+"out;");
                ps.println("AND cselandc"+(j+1)+"in1 cselandc"+(j+1)+"in2 cselandc"+(j+1)+"out;");
                ps.println("AND cselandd"+(j+1)+"in1 cselandd"+(j+1)+"in2 cselandd"+(j+1)+"out;");
            }
            ps.println("INV cselandainvin cselandainvout;");
            ps.println("INV cselandbinvin cselandbinvout;");
            ps.println("INV cselandcinvin cselandcinvout;");
            ps.println("INV cselanddinvin cselanddinvout;");
            int span2=4;
            int span2s=1;
            while(span2>0){
                for(int i=0;i<span2;i++){
                    ps.println("OR selor"+(i+1)+"x"+span2s+"in1 selor"+(i+1)+"x"+span2s+"in2 selor"+(i+1)+"x"+span2s+"out;");
                }
                span2=span2/2;
                span2s=span2s+1;
            }
            for(int j=0;j<16;j++){
                ps.println("AND dselanda"+(j+1)+"in1 dselanda"+(j+1)+"in2 dselanda"+(j+1)+"out;");
                ps.println("AND dselandb"+(j+1)+"in1 dselandb"+(j+1)+"in2 dselandb"+(j+1)+"out;");
                ps.println("AND dselandc"+(j+1)+"in1 dselandc"+(j+1)+"in2 dselandc"+(j+1)+"out;");
            }
            for(int i=0;i<16;i++){
                for(int j=0;j<32;j++){
                    ps.println("AND valand"+(i+1)+"x"+(j+1)+"in1 valand"+(i+1)+"x"+(j+1)+"in2 valand"+(i+1)+"x"+(j+1)+"out;");
                }
            }
            int span1=8;
            int span1s=1;
            while(span1>0){
                for(int i=0;i<span1;i++){
                    for(int j=0;j<32;j++){
                        ps.println("OR ortree"+(i+1)+"x"+(j+1)+"x"+span1s+"in1 ortree"+(i+1)+"x"+(j+1)+"x"+span1s+"in2 ortree"+(i+1)+"x"+(j+1)+"x"+span1s+"out;");
                    }
                }
                span1=span1/2;
                span1s=span1s+1;
            }
            ps.println("CONNECT sel1 sel1invin;");
            ps.println("CONNECT sel2 sel2invin;");
            ps.println("CONNECT sel3 sel3invin;");
            for(int i=0;i<8;i++){
                if(i%2==0){
                    ps.println("CONNECT sel1invout seland"+(i+1)+"in1;");
                }
                else{
                    ps.println("CONNECT sel1 seland"+(i+1)+"in1;");
                }
                if((i/2)%2==0){
                    ps.println("CONNECT sel2invout seland"+(i+1)+"in2;");
                }
                else{
                    ps.println("CONNECT sel2 seland"+(i+1)+"in2;");
                }
                if((i/4)%2==0){
                    ps.println("CONNECT sel3invout bseland"+(i+1)+"in1;");
                }
                else{
                    ps.println("CONNECT sel3 bseland"+(i+1)+"in1;");
                }
                ps.println("CONNECT seland"+(i+1)+"out bseland"+(i+1)+"in2;");
            }
            for(int i=0;i<8;i++){
                ps.println("CONNECT bseland"+(i+1)+"out cselanda"+(i+1)+"in1;");
                ps.println("CONNECT bseland"+(i+1)+"out cselandb"+(i+1)+"in1;");
                ps.println("CONNECT bseland"+(i+1)+"out cselandc"+(i+1)+"in1;");
                ps.println("CONNECT bseland"+(i+1)+"out cselandd"+(i+1)+"in1;");
                ps.println("CONNECT in"+(4*i+1)+" cselanda"+(i+1)+"in2;");
                ps.println("CONNECT in"+(4*i+2)+" cselandb"+(i+1)+"in2;");
                ps.println("CONNECT in"+(4*i+3)+" cselandc"+(i+1)+"in2;");
                ps.println("CONNECT in"+(4*i+4)+" cselandd"+(i+1)+"in2;");
            }
            int spanb=4;
            int stageb=1;
            while(spanb>0){
                for(int k=0;k<spanb;k++){
                    if(spanb==4){
                        ps.println("CONNECT cselanda"+(k*2+1)+"out selor"+(k+1)+"x"+stageb+"in1;");
                        ps.println("CONNECT cselanda"+(k*2+2)+"out selor"+(k+1)+"x"+stageb+"in2;");
                    }
                    else{
                        ps.println("CONNECT selor"+(k*2+1)+"x"+(stageb-1)+"out selor"+(k+1)+"x"+stageb+"in1;");
                        ps.println("CONNECT selor"+(k*2+2)+"x"+(stageb-1)+"out selor"+(k+1)+"x"+stageb+"in2;");
                    }
                }
                spanb=spanb/2;
                stageb=stageb+1;
            }
            ps.println("CONNECT selor1x3out cselandainvin;");
            ps.println("CONNECT selor1x3out cselandbinvin;");
            ps.println("CONNECT selor1x3out cselandcinvin;");
            ps.println("CONNECT selor1x3out cselanddinvin;");
            for(int j=0;j<16;j++){
                if(j%2==0){
                    ps.println("CONNECT cselandainvout dselanda"+(j+1)+"in1;");
                }
                else{
                    ps.println("CONNECT selor1x3out dselanda"+(j+1)+"in1;");
                }
                if((j/2)%2==0){
                    ps.println("CONNECT cselandbinvout dselanda"+(j+1)+"in2;");
                }
                else{
                    ps.println("CONNECT selor1x3out dselanda"+(j+1)+"in2;");
                }
                if((j/4)%2==0){
                    ps.println("CONNECT cselandcinvout dselandb"+(j+1)+"in1;");
                }
                else{
                    ps.println("CONNECT selor1x3out dselandb"+(j+1)+"in1;");
                }
                if((j/8)%2==0){
                    ps.println("CONNECT cselanddinvout dselandb"+(j+1)+"in2;");
                }
                else{
                    ps.println("CONNECT selor1x3out dselandb"+(j+1)+"in2;");
                }
                ps.println("CONNECT dselanda"+(j+1)+"out dselandc"+(j+1)+"in1;");
                ps.println("CONNECT dselandb"+(j+1)+"out dselandc"+(j+1)+"in2;");
            }
            for(int i=0;i<16;i++){
                long curl=colors[i];
                for(int j=0;j<32;j++){
                    ps.println("CONNECT dselandc"+(i+1)+"out valand"+(i+1)+"x"+(j+1)+"in1;");
                    if(curl%2==0){
                        ps.println("CONNECT c valand"+(i+1)+"x"+(j+1)+"in2;");
                    }
                    else{
                        ps.println("CONNECT d valand"+(i+1)+"x"+(j+1)+"in2;");
                    }
                    curl=curl/2;
                }
            }
            int span=8;
            int stage=1;
            while(span>0){
                for(int i=0;i<span;i++){
                    for(int j=0;j<32;j++){
                        if(span==8){
                            ps.println("CONNECT valand"+(2*i+1)+"x"+(j+1)+"out ortree"+(i+1)+"x"+(j+1)+"x"+stage+"in1;");
                            ps.println("CONNECT valand"+(2*i+2)+"x"+(j+1)+"out ortree"+(i+1)+"x"+(j+1)+"x"+stage+"in2;");
                        }
                        else{
                            ps.println("CONNECT ortree"+(2*i+1)+"x"+(j+1)+"x"+(stage-1)+"out ortree"+(i+1)+"x"+(j+1)+"x"+stage+"in1;");
                            ps.println("CONNECT ortree"+(2*i+2)+"x"+(j+1)+"x"+(stage-1)+"out ortree"+(i+1)+"x"+(j+1)+"x"+stage+"in2;");
                        }
                    }
                }
                span=span/2;
                stage++;
            }
            for(int i=0;i<32;i++){
                ps.println("CONNECT ortree1x"+(i+1)+"x4out out"+(i+1)+";");
            }
            ps.println("}");
            ps.println("MODULE main{");
            ps.println("CONSTANT c 0;");
            ps.println("CONSTANT d 1;");
            ps.println("COLORENCODER col;");
            for(int i=0;i<32;i++){
                ps.println("CONNECT d col.in"+(i+1)+";");
            }
            for(int i=0;i<3;i++){
                ps.println("CONNECT c col.sel"+(i+1)+";");
            }
            ps.println("}");
            fos.close();
        }
        catch(Exception e){};
    }
}
