import java.io.*;
class MemGenerator{
    public static void main(String[]args){
        try{
            int begin=new Integer(args[0]).intValue();
            int end=new Integer(args[1]).intValue();
            int[]filedata=new int[(end-begin+1)*4];
            if(args.length==3){
                String initfile=args[2];
                FileInputStream fis=new FileInputStream(initfile);
                int inp=-1;
                int c=0;
                while((inp=fis.read())!=-1){
                    filedata[c]=inp;
                    c++;
                }
                fis.close();
            }
            FileOutputStream fos=new FileOutputStream("mem.txt");
            PrintStream ps=new PrintStream(fos);
            ps.println("MODULE GLOBAND{");
            for(int i=1;i<=32;i++){
                ps.println("IN in"+i+";");
            }
            ps.println("OUT out;");
            for(int i=1;i<32;i++){
                ps.println("AND and"+i+"in1 and"+i+"in2 and"+i+"out;");
            }
            ps.println("CONNECT in1 and1in1;");
            for(int i=2;i<=32;i++){
                ps.println("CONNECT in"+i+" and"+(i-1)+"in2;");
            }
            for(int i=1;i<31;i++){
                ps.println("CONNECT and"+i+"out and"+(i+1)+"in1;");
            }
            ps.println("CONNECT and31out out;");
            ps.println("}");
            int fpos=0;
            for(int i=begin;i<=end;i++){
                int n=i;
                int[]bj=new int[32];
                for(int j=0;j<32;j++){
                    bj[j]=n%2;
                    n=n/2;
                }
                ps.println("MODULE mem"+i+"{");
                ps.println("IN read;");
                ps.println("IN write;");
                for(int j=1;j<=32;j++){
                    ps.println("IN readin"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("IN readat"+j+";");
                }
                ps.println("OUT reado;");
                ps.println("OUT writeo;");
                for(int j=1;j<=32;j++){
                    ps.println("OUT readino"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OUT readato"+j+";");
                }
                ps.println("INV invin invout;");
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("INV inv"+(j+1)+"in inv"+(j+1)+"out;");
                    }
                }
                ps.println("GLOBAND glob;");
                ps.println("AND readandin1 readandin2 readandout;");
                ps.println("AND writeandin1 writeandin2 writeandout;");
                int val1=filedata[fpos];
                for(int j=25;j<=32;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                val1=filedata[fpos];
                for(int j=17;j<=24;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                val1=filedata[fpos];
                for(int j=9;j<=16;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                val1=filedata[fpos];
                for(int j=1;j<=8;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                for(int j=1;j<=32;j++){
                    ps.println("AND aand"+j+"in1 aand"+j+"in2 aand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND band"+j+"in1 band"+j+"in2 band"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR or"+j+"in1 or"+j+"in2 or"+j+"out;");
                }
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("CONNECT readat"+(j+1)+" inv"+(j+1)+"in;");
                        ps.println("CONNECT inv"+(j+1)+"out glob.in"+(j+1)+";");
                    }
                    else{
                        ps.println("CONNECT readat"+(j+1)+" glob.in"+(j+1)+";");
                    }
                }
                ps.println("CONNECT read readandin1;");
                ps.println("CONNECT glob.out readandin2;");
                ps.println("CONNECT write writeandin1;");
                ps.println("CONNECT glob.out writeandin2;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT readandout bitread"+j+";");
                    ps.println("CONNECT writeandout bitset"+j+";");
                    ps.println("CONNECT readin"+j+" bitin"+j+";");
                    ps.println("CONNECT bitout"+j+" aand"+j+"in1;");
                    ps.println("CONNECT readandout aand"+j+"in2;");
                }
                ps.println("CONNECT readandout invin;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT invout band"+j+"in1;");
                    ps.println("CONNECT readin"+j+" band"+j+"in2;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT aand"+j+"out or"+j+"in1;");
                    ps.println("CONNECT band"+j+"out or"+j+"in2;");
                    ps.println("CONNECT or"+j+"out readino"+j+";");
                    ps.println("CONNECT readat"+j+" readato"+j+";");
                }
                ps.println("CONNECT read reado;");
                ps.println("CONNECT write writeo;");
                ps.println("}");
            }
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
}
