import java.io.*;
class MemGeneratorQVGA{
    public static void main(String[]args){
        try{
            int begin=new Integer(args[0]).intValue();
            int end=new Integer(args[1]).intValue();
            FileOutputStream fos=new FileOutputStream("mem.txt");
            PrintStream ps=new PrintStream(fos);
            ps.println("MODULE GLOBAND{");
            for(int i=1;i<=32;i++){
                ps.println("IN in"+i+";");
            }
            ps.println("OUT out;");
            for(int i=1;i<32;i++){
                ps.println("AND and"+i+"in1 and"+i+"in2 and"+i+"out;");
            }
            ps.println("CONNECT in1 and1in1;");
            for(int i=2;i<=32;i++){
                ps.println("CONNECT in"+i+" and"+(i-1)+"in2;");
            }
            for(int i=1;i<31;i++){
                ps.println("CONNECT and"+i+"out and"+(i+1)+"in1;");
            }
            ps.println("CONNECT and31out out;");
            ps.println("}");
            ps.println("MODULE LASTCONTENT{");
            ps.println("CYCLE 1;");
            for(int i=1;i<=32;i++){
                ps.println("IN in"+i+";");
            }
            for(int i=1;i<=32;i++){
                ps.println("OUT out"+i+";");
            }
            for(int i=1;i<=32;i++){
                ps.println("CONNECT in"+i+" out"+i+";");
            }
            ps.println("}");
            for(int i=begin;i<=end;i++){
                int n=i;
                int[]bj=new int[32];
                for(int j=0;j<32;j++){
                    bj[j]=n%2;
                    n=n/2;
                }
                ps.println("MODULE mem"+i+"{");
                ps.println("IN read;");
                ps.println("IN write;");
                for(int j=1;j<=32;j++){
                    ps.println("IN readin"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("IN readat"+j+";");
                }
                ps.println("OUT reado;");
                ps.println("OUT writeo;");
                for(int j=1;j<=32;j++){
                    ps.println("OUT readino"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OUT readato"+j+";");
                }
                ps.println("INV invin invout;");
                ps.println("INV cinvin cinvout;");
                ps.println("INV dinvin dinvout;");
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("INV inv"+(j+1)+"in inv"+(j+1)+"out;");
                    }
                }
                if(!(bj[15]==0)){
                    ps.println("INV binv16in binv16out;");
                }
                ps.println("GLOBAND glob;");
                ps.println("GLOBAND bglob;");
                ps.println("LASTCONTENT lc;");
                ps.println("LASTCONTENT blc;");
                ps.println("CONSTANT d 1;");
                ps.println("AND readandin1 readandin2 readandout;");
                ps.println("AND writeandin1 writeandin2 writeandout;");
                ps.println("OR writeorin1 writeorin2 writeorout;");
                ps.println("AND breadandin1 breadandin2 breadandout;");
                ps.println("AND bwriteandin1 bwriteandin2 bwriteandout;");
                ps.println("OR bwriteorin1 bwriteorin2 bwriteorout;");
                ps.println("OR abreadorin1 abreadorin2 abreadorout;");
                for(int j=1;j<=32;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" 0;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("BIT bbitin"+j+" bbitout"+j+" bbitread"+j+" bbitset"+j+" 0;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND aand"+j+"in1 aand"+j+"in2 aand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND baand"+j+"in1 baand"+j+"in2 baand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND band"+j+"in1 band"+j+"in2 band"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND cand"+j+"in1 cand"+j+"in2 cand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND dand"+j+"in1 dand"+j+"in2 dand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR or"+j+"in1 or"+j+"in2 or"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR cor"+j+"in1 cor"+j+"in2 cor"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND bcand"+j+"in1 bcand"+j+"in2 bcand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND bdand"+j+"in1 bdand"+j+"in2 bdand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR bcor"+j+"in1 bcor"+j+"in2 bcor"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR bor"+j+"in1 bor"+j+"in2 bor"+j+"out;");
                }
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("CONNECT readat"+(j+1)+" inv"+(j+1)+"in;");
                        ps.println("CONNECT inv"+(j+1)+"out glob.in"+(j+1)+";");
                    }
                    else{
                        ps.println("CONNECT readat"+(j+1)+" glob.in"+(j+1)+";");
                    }
                }
                for(int j=0;j<32;j++){
                    if(j!=15){
                        if(bj[j]==0){
                            ps.println("CONNECT inv"+(j+1)+"out bglob.in"+(j+1)+";");
                        }
                        else{
                            ps.println("CONNECT readat"+(j+1)+" bglob.in"+(j+1)+";");
                        }
                    }
                    else{
                        if(!(bj[j]==0)){
                            ps.println("CONNECT binv"+(j+1)+"out bglob.in"+(j+1)+";");
                        }
                        else{
                            ps.println("CONNECT readat"+(j+1)+" bglob.in"+(j+1)+";");
                        }
                    }
                }
                ps.println("CONNECT read readandin1;");
                ps.println("CONNECT glob.out readandin2;");
                ps.println("CONNECT write writeandin1;");
                ps.println("CONNECT glob.out writeandin2;");
                ps.println("CONNECT readat18 writeorin1;");
                ps.println("CONNECT writeandout writeorin2;");
                ps.println("CONNECT readat18 dinvin;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT d bitread"+j+";");
                    ps.println("CONNECT writeorout bitset"+j+";");
                    ps.println("CONNECT readat18 cand"+j+"in1;");
                    ps.println("CONNECT blc.out"+j+" cand"+j+"in2;");
                    ps.println("CONNECT dinvout dand"+j+"in1;");
                    ps.println("CONNECT readin"+j+" dand"+j+"in2;");
                    ps.println("CONNECT cand"+j+"out cor"+j+"in1;");
                    ps.println("CONNECT dand"+j+"out cor"+j+"in2;");
                    ps.println("CONNECT cor"+j+"out bitin"+j+";");
                    ps.println("CONNECT bitout"+j+" aand"+j+"in1;");
                    ps.println("CONNECT readandout aand"+j+"in2;");
                    ps.println("CONNECT bitout"+j+" lc.in"+j+";");
                }
                ps.println("CONNECT read breadandin1;");
                ps.println("CONNECT bglob.out breadandin2;");
                ps.println("CONNECT write bwriteandin1;");
                ps.println("CONNECT bglob.out bwriteandin2;");
                ps.println("CONNECT readat17 bwriteorin1;");
                ps.println("CONNECT bwriteandout bwriteorin2;");
                ps.println("CONNECT readat17 cinvin;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT d bbitread"+j+";");
                    ps.println("CONNECT bwriteorout bbitset"+j+";");
                    ps.println("CONNECT readat17 bcand"+j+"in1;");
                    ps.println("CONNECT lc.out"+j+" bcand"+j+"in2;");
                    ps.println("CONNECT cinvout bdand"+j+"in1;");
                    ps.println("CONNECT readin"+j+" bdand"+j+"in2;");
                    ps.println("CONNECT bcand"+j+"out bcor"+j+"in1;");
                    ps.println("CONNECT bdand"+j+"out bcor"+j+"in2;");
                    ps.println("CONNECT bcor"+j+"out bbitin"+j+";");
                    ps.println("CONNECT bbitout"+j+" baand"+j+"in1;");
                    ps.println("CONNECT breadandout baand"+j+"in2;");
                    ps.println("CONNECT bbitout"+j+" blc.in"+j+";");
                }
                ps.println("CONNECT readandout abreadorin1;");
                ps.println("CONNECT breadandout abreadorin2;");
                ps.println("CONNECT abreadorout invin;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT invout band"+j+"in1;");
                    ps.println("CONNECT readin"+j+" band"+j+"in2;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT aand"+j+"out or"+j+"in1;");
                    ps.println("CONNECT band"+j+"out or"+j+"in2;");
                    ps.println("CONNECT or"+j+"out bor"+j+"in1;");
                    ps.println("CONNECT baand"+j+"out bor"+j+"in2;");
                    ps.println("CONNECT bor"+j+"out readino"+j+";");
                    ps.println("CONNECT readat"+j+" readato"+j+";");
                }
                ps.println("CONNECT read reado;");
                ps.println("CONNECT write writeo;");
                ps.println("}");
            }
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
}
