import java.io.*;
class AddMemGenerator{
    public static void main(String[]args){
        try{
            long begin=new Long(args[0]).longValue();
            long end=new Long(args[1]).longValue();
            FileOutputStream fos=new FileOutputStream("addmem.txt");
            PrintStream ps=new PrintStream(fos);
            for(long iv=begin;iv<=end;iv++){
                int i=(int)iv;
                long n=iv;
                long[]bj=new long[32];
                for(int j=0;j<32;j++){
                    bj[j]=n%2;
                    n=n/2;
                }
                ps.println("MODULE mem"+iv+"{");
                ps.println("IN read;");
                ps.println("IN write;");
                for(int j=1;j<=32;j++){
                    ps.println("IN readin"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("IN readat"+j+";");
                }
                ps.println("OUT reado;");
                ps.println("OUT writeo;");
                for(int j=1;j<=32;j++){
                    ps.println("OUT readino"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OUT readato"+j+";");
                }
                ps.println("FP16ADDER adder;");
                ps.println("INV invin invout;");
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("INV inv"+(j+1)+"in inv"+(j+1)+"out;");
                    }
                }
                ps.println("GLOBAND glob;");
                ps.println("AND readandin1 readandin2 readandout;");
                ps.println("AND writeandin1 writeandin2 writeandout;");
                for(int j=1;j<=32;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" 0;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND aand"+j+"in1 aand"+j+"in2 aand"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("AND band"+j+"in1 band"+j+"in2 band"+j+"out;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OR or"+j+"in1 or"+j+"in2 or"+j+"out;");
                }
                for(int j=0;j<32;j++){
                    if(bj[j]==0){
                        ps.println("CONNECT readat"+(j+1)+" inv"+(j+1)+"in;");
                        ps.println("CONNECT inv"+(j+1)+"out glob.in"+(j+1)+";");
                    }
                    else{
                        ps.println("CONNECT readat"+(j+1)+" glob.in"+(j+1)+";");
                    }
                }
                ps.println("CONNECT read readandin1;");
                ps.println("CONNECT glob.out readandin2;");
                ps.println("CONNECT write writeandin1;");
                ps.println("CONNECT glob.out writeandin2;");
                for(int j=0;j<16;j++){
                    ps.println("CONNECT bitout"+(j+1)+" adder.ain"+(j+1)+";");
                    ps.println("CONNECT bitout"+(j+17)+" adder.bin"+(j+1)+";");
                    ps.println("CONNECT adder.out"+(j+1)+" aand"+(j+1)+"in1;");
                    ps.println("CONNECT adder.out"+(j+1)+" aand"+(j+17)+"in1;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT readandout bitread"+j+";");
                    ps.println("CONNECT writeandout bitset"+j+";");
                    ps.println("CONNECT readin"+j+" bitin"+j+";");
                    ps.println("CONNECT readandout aand"+j+"in2;");
                }
                ps.println("CONNECT readandout invin;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT invout band"+j+"in1;");
                    ps.println("CONNECT readin"+j+" band"+j+"in2;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT aand"+j+"out or"+j+"in1;");
                    ps.println("CONNECT band"+j+"out or"+j+"in2;");
                    ps.println("CONNECT or"+j+"out readino"+j+";");
                    ps.println("CONNECT readat"+j+" readato"+j+";");
                }
                ps.println("CONNECT read reado;");
                ps.println("CONNECT write writeo;");
                ps.println("}");
            }
        }
        catch(Exception e){
        }
    }
}
